#include<stdio.h>
#include<stdlib.h>
#include<math.h>

#define size	3	//matrix size


void matrix_multi( double x[size][size] , double y[size][size] , double z[size][size]){
	int i ,j, k;
	
	for(i=0; i<size; i++){
		for(j=0 ; j< size; j++){
			z[i][j] = 0.0;
			for(k=0;k<size ; k++){
				z[i][j] += x[i][k] * y[k][j];
			}
		}
	}
}

int matrix_inv( double x[size][size] , double inv[size][size]){
	double tmp;
	int i,j,pivot;
	double max;
	int max_row;
	
	
	for(i=0;i<size;i++){
		for(j=0;j<size;j++){
			inv[i][j] = (i==j)? 1.0 : 0.0 ;
		}
	}
	
	for( pivot=0 ; pivot<size ; pivot++ ){	//pivot
		
		max = 0.0;
		for(i= pivot ; i<size ; i++ ){
			if( fabs(x[i][pivot]) > max ){
				max = fabs(x[i][pivot]);
				max_row = i;
			}
		}
		if( max == 0.0 ){
			printf("not exist\a\n");
			return -1;
		}
		if( pivot != max_row ){
			for( j=0; j<size ; j++ ){
				tmp = x[pivot][j];
				x[pivot][j] = x[max_row][j];
				x[max_row][j] = tmp;
				
				tmp = inv[pivot][j];
				inv[pivot][j] = inv[max_row][j];
				inv[max_row][j] = tmp;
				
			}
		}
		
		
		
		tmp = 1.0/x[pivot][pivot];
		for(j=0;j<size ; j++){
			x[pivot][j] *= tmp;
			inv[pivot][j] *= tmp;
		}
		
		
		for(i=0;i<size; i++){	//for1
			if( pivot != i ){
				tmp = x[i][pivot];
				for( j = 0 ; j < size ; j ++){
					x[i][j] -= x[pivot][j]*tmp;
					inv[i][j] -= inv[pivot][j]*tmp;
				}
			}
		}	//for1
		
	}	//pivot
	
	for( i=0 ;i<size ; i++){
		for(j=0; j<size ; j++ ){
			if( inv[i][j] > pow(10,5) ){
				printf("incredible\a\n");
				return -1;
			}
		}
	}
	
	
	return 1;
}




int main(void){
	int i,j;
	double x[size][size]={{3,0,1},{1,2,0},{1,1,-1}};
	double y[size][size]={{1,0,3},{1,1,0},{2,0,1}};
	
	double z[size][size];
	matrix_multi(x,y,z);
	double inv[size][size] = {0.0};
	matrix_inv(x , inv);
	for(i=0;i<size;i++){
		for(j=0;j<size;j++){
			printf("%f	",z[i][j]);
		}
		printf("\n");
	}
	printf("\n");
	
	for(i=0;i<size;i++){
		for(j=0;j<size;j++){
			printf("%f	",inv[i][j]);
		}
		printf("\n");
	}
	
	
	return 0;
}
